// OuttaStock.com Wii Finder v. 2.0

var url="http://widget.outtastock.com/summary_wii.txt";			
var timerInterval=null;
var refresh=2000;
var last_updated = 0;
var xml_request = null;
var useGrowl = false;
var growlRegistered = null;
var runInBackGround = true;
var clickURL = "http://www.outtastock.com/wii/";

function load()
{
	setupParts();
	loadPrefs();
	checkGrowl();
}

function remove()
{
	widget.setPreferenceForKey(null, createInstancePreferenceKey("maxprice"));
}

function onhide()
{
    //if (timerInterval != null) {
    //    clearInterval(timerInterval);
    //    timerInterval = null;
    // }
}

function onshow()
{
    if (timerInterval == null) {
        timerInterval = setInterval("show();", refresh);
    }
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function show()
{
	var now = (new Date).getTime();
	
	// only check if 1 minutes have passed
	if ((now - last_updated) > 60000)
	{
		document.getElementById("stocktext").setAttribute("style","color:#3999c9;");
		document.getElementById("stocktext").innerText = "Pending Update";
		document.getElementById("helpertext").innerText = "";
		
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {summary_loaded(e, xml_request);}
		xml_request.open("GET", url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
    }
}

function summary_loaded (e, request) 
{
	xml_request = null;
	var link = document.getElementById("stocktext");
	var maxprice = document.getElementById("maxprice").value * 1;
	
	if (request.responseText)
	{		
		var products = request.responseText.split(/\n/g);
		var alert = false;
		
		for (i=0; i<products.length-1; i++) {
		
			var product = products[i].split(",");
			if (product[2].replace(/\$/g,"")*1 <= maxprice || maxprice == 0.00)
				alert = true;
		}
		
		if (alert)
		{
			link.setAttribute("style","color:#90DD00;");
			link.innerText = "Wii in Stock!";
			document.getElementById("helpertext").innerText = "Click here now!";
			if (useGrowl && growlRegistered) {
				growlAlert("Wii are in Stock!");
			}
		}
		else
		{
			link.setAttribute("style","color:#CCCCCC;");
			link.innerText = "No Wii Available";
			document.getElementById("helpertext").innerText = "www.OuttaStock.com";
			
		}
				
	}
	else
	{
		link.setAttribute("style","color:#CCCCCC;");
		link.innerText = "No Wii Available";
		document.getElementById("helpertext").innerText = "www.OuttaStock.com";
	}	

	// set last_updated to the current time to keep track of the last time a request was posted
	last_updated = (new Date).getTime();
}

function click() {
	if (widget)
	{
		widget.openURL(clickURL);
	}
}

function loadPrefs() {
	var maxprice = widget.preferenceForKey("maxprice");
	if (maxprice) {
		document.getElementById("maxprice").value = maxprice;		
	}
}

// Growl stuff
function registerGrowl() {
	var obj = widget.system("/usr/bin/osascript scripts/RegisterGrowl.scpt", registerGrowlHandler);
}

function registerGrowlHandler(response) {
	var output = response.errorString;
	if (!output) {
		growlRegistered = true;
	}
}

function checkGrowl() {
	
    var obj = widget.system("/usr/bin/osascript scripts/CheckGrowl.scpt", checkGrowlHandler);
	
}

function checkGrowlHandler(response) {

	var output = response.outputString;
	if (output == "true\n") {
		useGrowl = true;
	} else {
		useGrowl = false;
	}
	
	if (useGrowl == true) {
			registerGrowl();
	}
}


function growlAlert(message) {
	var obj = widget.system("/usr/bin/osascript scripts/GrowlAlert.scpt " + message.replace(/([^a-zA-Z0-9])/g, '\\$1'), null);
}

function growlAlertHandler(response) {
	return;
}


// Max Price validation
function isValidPrice(obj) {

	val = obj.value;
	if (isNaN(val))
		val=0;
	obj.value=(parseFloat(val)).toFixed(2);
	widget.setPreferenceForKey(obj.value, "maxprice");

}



if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = onhide;
	widget.onshow = onshow;
}
